#include <FL/Fl.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Input.H>

#include <stdio.h>

static Fl_Double_Window *win1;
static Fl_Input *inp;

class pop_win : public Fl_Double_Window {
public:
	pop_win(int W, int H) :
	    Fl_Double_Window(W,H),
	    map_pending(0) {};

	~pop_win() {map_pending = 0;}

	void show(){
		Fl_Double_Window::show();
		map_pending = 1;
	}

	void hide(){
		Fl_Double_Window::hide();
		map_pending = 0;
	}

	void draw() {
		Fl_Double_Window::draw();
		map_pending = 0;
	}

	int wait_map() {return map_pending;}

private:
	int map_pending;
}; // pop_win


static pop_win *win2;


static void popup(Fl_Widget *, void *) {

	win2->position(win1->x() + win1->w(), win1->y());

	win2->show();
	while (win2->wait_map()) {
		Fl::wait(0);
	}
	inp->take_focus();
}

int main(int argc, char**argv) {

	win1 = new Fl_Double_Window(300, 200);
	win1->label("window1");

	Fl_Box *b = new Fl_Box(10, 10, 280, 130);
	b->label("Type something to pop the subwindow up. "
			"The focus should stay on the input, "
			"and you should be able to continue typing.");
	b->align(FL_ALIGN_WRAP | FL_ALIGN_LEFT | FL_ALIGN_INSIDE);

	inp = new Fl_Input(10, 150, 150, 25);
	inp->when(FL_WHEN_CHANGED);
	inp->callback(popup);

	win1->end();

	win2 = new pop_win(300, 200);
	win2->label("window2");
	win2->end();

	win1->show(argc, argv);

	return Fl::run();
}
